From 65ad2d664f6667200d7edadaba3a9acdec60c7ff Mon Sep 17 00:00:00 2001
From: Jefferson Carpenter <jefferson.carpenter@transunion.com>
Date: Wed, 25 Sep 2019 16:03:49 -0500
Subject: [PATCH] Add setting to allow switching to an already-visible buffer
 by default

---
 lisp/window.el | 10 +++++++++-
 1 file changed, 9 insertions(+), 1 deletion(-)

diff --git a/lisp/window.el b/lisp/window.el
index 620eacdd29..13009ee5ee 100644
--- a/lisp/window.el
+++ b/lisp/window.el
@@ -8158,6 +8158,13 @@ currently selected window; otherwise it will be displayed in
 another window."
   (pop-to-buffer buffer display-buffer--same-window-action norecord))
 
+(defcustom switch-to-buffer-visible-ok nil
+  "If non-nil, switch-to-buffer interactive prompt does not
+  prefer non-visible buffers."
+  :type 'boolean
+  :initialize 'custom-initialize-default
+  :group 'windows)
+
 (defun read-buffer-to-switch (prompt)
   "Read the name of a buffer to switch to, prompting with PROMPT.
 Return the name of the buffer as a string.
@@ -8178,7 +8185,8 @@ from the list of completions and default values."
               (set (make-local-variable 'icomplete-with-completion-tables)
                    (cons rbts-completion-table
                          icomplete-with-completion-tables))))
-      (read-buffer prompt (other-buffer (current-buffer))
+      (read-buffer prompt (other-buffer (current-buffer)
+                                        switch-to-buffer-visible-ok)
                    (confirm-nonexistent-file-or-buffer)))))
 
 (defun window-normalize-buffer-to-switch-to (buffer-or-name)
-- 
2.20.1 (Apple Git-117)

